HDU 2955解题报告

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 12196    Accepted Submission(s): 4541



Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.
His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
Sample Input
  
  
3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
Sample Output
  
  
2 4 6
Source
 
Recommend
gaojie   |   We have carefully selected several similar problems for you:  2602 1203 2159 2844 1171

解题思路

       这道题属于01背包的经典题,与概率相结合。题目大意是在保证小于被抓的概率之下偷到更多的钱。。但是与一般的01背包对比的话,我们会发现不同的地方,如果将dp[i]作为获得的钱的数量的话,这个i就是被抓的概率,但是由于概率是浮点数,而且浮点数的位数也不确定,即使通过对浮点数放大一定的倍数也不一定能得到正确答案。所以我们要考虑概率与钱数这两者之间的关系。取到的钱数越多越好,只要不被抓住就好。也就是在取到钱数尽可能多的情况下,被抓的概率尽可能小。如果从被抓的角度考虑的话,dp[0]表示偷走0元钱的概率,那么dp[0]=0,在状态转移时我们要考虑不偷走当前的钱和偷走当前的钱这两种决策。而dp[i]代表偷走i元钱时被抓的概率,在算被抓的概率时,他在这一次可能被抓,也可能没有被抓,但是总的来说至少有一次被抓。通过概率的学习我们知道,这样的情况是很多的,状态转移方程也比较难写。所以考虑被抓的概率是不太可行的。

       所以我们要从反面考虑,考虑他能够逃走的概率,能够逃走保证了每一次都不会被抓,这样情况数就大大减少。我们知道取到钱数越多,被抓的概率越小,这种情况一定是最优的,所以能够逃走的概率越大越好。这样便可以很容易的写出状态转移方程。

参考代码

#include<cstdio>
#include<iostream>
#define CLR(x) memset(x,0,sizeof(x))
using namespace std;
const int maxn=10010;
int cost[maxn];
float p[maxn];
float dp[maxn];
int main()
{
    int t,n;
    scanf("%d",&t);
    float num;
    while(t--)
    {
        CLR(dp);
        scanf("%f%d",&num,&n);
        int sum=0;
        for(int i=1; i<=n; i++)
        {
            scanf("%d%f",&cost[i],&p[i]);
            p[i]=1.0-p[i];
            sum+=cost[i];
        }
        dp[0]=1.0;            //从反面考虑
        for(int i=1; i<=n; i++)
            for(int j=sum;j>=cost[i]; j--)
                dp[j]=max(dp[j],dp[j-cost[i]]*p[i]);
        int k;
        for(k=sum; k>=1; k--)
            if(dp[k]+num>=1.0)
                break;
        printf("%d\n",k);  //如果写在for循环的if语句中会跪
    }
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值